def decode_enum(enum_dict: dict):
    def decode(value):
        if value not in enum_dict:
            return enum_dict[KeyError]
        return enum_dict[value]

    return decode


ncom_nav_status = {
    KeyError: 'Reserved',
    0: 'Invalid',
    1: 'Raw_IMU_measurements',
    2: 'Initializing',
    3: 'Locking',
    4: 'Locked',
    5: 'Reserved',
    6: 'Expired_firmware',
    7: 'Blocked_firmware',
    10: 'Status_only',
    11: 'Internal_use',
    20: 'Trigger_packet_initializing',
    21: 'Trigger_packet_locking',
    22: 'Trigger_packet_locked',
}
ncom_channel_status = {
    KeyError: 'Reserved_for_future_use',
    0: 'Time_satellites_mode',
    1: 'Kalman_filter_innovations_1',
    2: 'Internal_info_primary_antenna',
    3: 'Position_accuracy',
    4: 'Velocity_accuracy',
    5: 'Orientation_accuracy',
    6: 'Gyro_bias',
    7: 'Accelerometer_bias',
    8: 'Gyro_scale_factor',
    9: 'Gyro_bias_accuracy',
    10: 'Accelerometer_accuracy',
    11: 'Gyro_scalr_factor_accuracy',
    12: 'Position_estimate_primary_antenna',
    13: 'Orientation_estimate_dual_antenna',
    14: 'Position_accuracy_primary_antenna',
    15: 'Orientation_accuracy_dual_antenna',
    16: 'INS_rotation',
    17: 'Internal_info_secondary_antenna',
    18: 'Internal_info_IMU',
    19: 'INS_SW_version',
    20: 'Differential_correction_info',
    21: 'Disk_space_log_size',
    22: 'Internal_info_processing_timing',
    23: 'Up_time_GNSS_rejections_PTP_status',
    24: 'Asynchronous_packet_event_input_falling_edge',
    25: 'Reserved',
    26: 'Displacement_lever_arm',
    27: 'Internal_info_dual_antenna_ambiguity',
    28: 'Internal_info_dual_antenna_ambiguity',
    29: 'Initial_settings_NAVconfig',
    30: 'OS_script_version_info',
    31: 'HW_config_info',
    32: 'Kalman_filter_innovation_2',
    33: 'Zero_velocity_lever_arm',
    34: 'Zero_velocity_lever_arm_accuracy',
    35: 'Lateral_advanced_slip_lever_arm',
    36: 'Lateral_advanced_slip_lever_arm_accuracy',
    37: 'Heading_misalignment_angle',
    38: 'Zero_velocity_option_settings_third_serial_output_mode',
    39: 'Lateral_advanced_slip_option_settings',
    40: 'NCOM_version_Id',
    41: 'Output_baud_rates_WiFI_IP_address',
    42: 'Heading_lock_options',
    43: 'Asynchronous_packet_triggered_by_rising_edge_of_event_input',
    44: 'Wheel_speed_configuration',
    45: 'Wheel_speed_counts',
    46: 'Wheel_speed_lever_arm',
    47: 'Wheel_speed_lever_arm_accuracy',
    48: 'Undulation_dilution_of_precision_of_GPS_datum_information',
    49: 'OmniSTAR_tracking_information',
    50: 'Information_sent_to_the_command_decoder',
    51: 'Additional_slip_point_1_lever_arm',
    52: 'Additional_slip_point_2_lever_arm',
    53: 'Additional_slip_point_3_lever_arm',
    54: 'Additional_slip_point_4_lever_arm',
    55: 'Information_about_the_primary_GNSS_receiver',
    56: 'Information_about_the_secondary_GNSS_receiver',
    57: 'Position_estimate_of_the_primary_GNSS_antenna',
    58: 'Vehicle_to_output_frame_rotation',
    59: 'IMU_decoding_status',
    60: 'Definition_of_the_surface_angles',
    61: 'Internal_information_about_external_GNSS_receiver',
    62: 'Information_about_the_external_GNSS_receiver',
    63: 'Angular_acceleration_filter_settings',
    64: 'Hardware_information_and_external_GNSS_receiver_configuration',
    65: 'Asynchronous_packet_triggered_by_camera_distance_output',
    66: 'Extended_local_coordinate_definition_latitude_and_longitude',
    67: 'Extended_local_coordinate_definition_altitude_and_heading',
    68: 'Additional_slip_point_5_lever_arm',
    69: 'Additional_slip_point_6_lever_arm',
    70: 'Additional_slip_point_7_lever_arm',
    71: 'Additional_slip_point_8_lever_arm',
    72: 'Status_information',
    73: 'Status_information',
    74: 'Linear_acceleration_filter_settings',
    75: 'Miscellaneous',
    76: 'Internal_information_about_differential_corrections',
    77: 'Differential_correction_configuration',
    78: 'CAN_bus_status_information',
    79: 'Asynchronous_packet_triggered_by_falling_edge_of_event_input_2',
    80: 'Asynchronous_packet_triggered_by_rising_edge_of_event_input_2',
    81: 'Asynchronous_packet_triggered_by_camera_distance_output_2',
    82: 'Hardware_configuration_information',
    83: 'Status_information',
    84: 'Status_information',
    85: 'Software_version_information',
    86: 'Reserved_for_future_use',
    87: 'Linear_jerk_filter_settings',
    88: 'Kalman_filter_innovations_3',
    89: 'Vertical_advanced_slip_lever_arm',
    90: 'Vertical_advanced_slip_lever_arm_accuracy',
    91: 'Pitch_misalignment_angle',
    92: 'Vertical_advanced_slip_option_settings',
    93: 'Galileo_and_Beidou_Satellite_Used_counts',
    94: 'Galileo_and_Beidou_Satellite_L1_L2_counts',
    95: 'Generic_aiding_packet_information',
}
ncom_position_velocity_orientation_mode = {
    KeyError: 'Reserved',
    0: 'None',
    1: 'Search',
    2: 'Doppler',
    3: 'SPS',
    4: 'Differential',
    5: 'RTK_Float',
    6: 'RTK_Integer',
    7: 'WAAS',
    8: 'OmniSTAR',
    9: 'OmniSTAR_HP',
    10: 'No_data',
    11: 'Blanked',
    12: 'Doppler_PP',
    13: 'SPS_PP',
    14: 'Differential_PP',
    15: 'RTK_Float_PP',
    16: 'RTK_Integer_PP',
    17: 'OmniSTAR_XP',
    18: 'CDGPS',
    19: 'Not_recognized',
    20: 'gxDoppler',
    21: 'gxSPS',
    22: 'gxDifferential',
    23: 'gxFloat',
    24: 'gxInteger',
    25: 'ixDoppler',
    26: 'ixSPS',
    27: 'ixDifferential',
    28: 'ixFloat',
    29: 'ixInteger',
    30: 'PPP_converging',
    31: 'PPP',
    32: 'Unknown',
}
ncom_blended_processing_methods = {
    KeyError: 'Reserved',
    0: 'Invalid',
    1: 'Real_time',
    2: 'Simulated',
    3: 'Post_process_forward',
    4: 'Post_process_backward',
    5: 'Post_process_combined',
    6: 'Unknown',
}
ncom_ptp_status = {
    KeyError: 'Value_not_in_documentation',
    0: 'PTP_status_invalid',
    1: 'PTP_status_initializing',
    2: 'PTP_status_faulty',
    3: 'PTP_status_disabled',
    4: 'PTP_status_listening',
    5: 'PTP_status_pre_master',
    6: 'PTP_status_master',
    7: 'PTP_status_passive',
    8: 'PTP_status_uncalibrated',
    9: 'PTP_status_slave',
    10: 'PTP_status_locked',
    11: 'PTP_status_config_error',
    12: 'PTP_status_critical_error',
    13: 'PTP_status_unknown',
}
rcom_lane_status_channel = {
    KeyError: 'Value_not_in_documentation',
    0: 'GPS_coarse_time',
    1: 'RT-Range_SW_dev_ID',
    2: 'Map_number',
    6: 'OS_and_script_version',
    7: 'UTC_offset_CPU_load',
    8: 'Point_A_lever-arm',
    9: 'Point_B_lever-arm',
    10: 'Point_C_lever-arm',
    15: 'Command_communication_status',
}
rcom_ex_range_status_channel = {
    KeyError: 'Value_not_in_documentation',
    1: 'Latency_measurement',
    2: 'RT-Range_SW_dev_ID',
    3: 'Target_wireless_LAN_communication_status',
    4: 'Hunter_ethernet_communication_status',
    5: 'Range_output_latency_offset_measurement',
    6: 'OS_and_script_version',
    7: 'UTC_offset_CPU_load',
    8: 'Fixed_point_position',
    9: 'Hunter_target_IP_addresses',
    10: 'Fixed_point_altitude',
    11: 'RT-Range_local_coordinate_origin_latitude_longitude',
    12: 'RT-Range_local_coordinate_origin_altitude_heading',
    13: 'Hunter_lever_arm',
    14: 'Target_lever_arm',
    15: 'Command_communication_status',
    16: 'Range_accuracy',
    17: 'Target_vehicle_geometry',
    18: 'Acceleration_filter_settings',
    19: 'Extrapolation_filter_settings',
    20: 'Feature_point_position',
    21: 'Feature_point_altitude_heading',
    22: 'Hunter_vehicle_geometry',
}
